VTK: vtkCylindricalTransform Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
vtkCylindricalTransform Class Reference

cylindrical to rectangular coords and back More...

`#include <vtkCylindricalTransform.h>`

Inheritance diagram for vtkCylindricalTransform:
[legend]
Collaboration diagram for vtkCylindricalTransform:
[legend]

## Public Types
typedef vtkWarpTransform | Superclass
Public Types inherited from vtkWarpTransform
typedef vtkAbstractTransform | Superclass
Public Types inherited from vtkAbstractTransform
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkCylindricalTransform * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
vtkAbstractTransform * | MakeTransform () override
| Make another transform of the same type. More...
Public Member Functions inherited from vtkWarpTransform
vtkWarpTransform * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | Inverse () override
| Invert the transformation. More...
virtual vtkTypeBool | GetInverseFlag ()
| Get the inverse flag of the transformation. More...
virtual void | SetInverseTolerance (double)
| Set the tolerance for inverse transformation. More...
virtual double | GetInverseTolerance ()
| Set the tolerance for inverse transformation. More...
virtual void | SetInverseIterations (int)
| Set the maximum number of iterations for the inverse transformation. More...
virtual int | GetInverseIterations ()
| Set the maximum number of iterations for the inverse transformation. More...
void | InternalTransformPoint (const float in[3], float out[3]) override
| This will calculate the transformation without calling Update. More...
void | InternalTransformPoint (const double in[3], double out[3]) override
| This will calculate the transformation without calling Update. More...
void | InternalTransformDerivative (const float in[3], float out[3], float derivative[3][3]) override
| This will calculate the transformation, as well as its derivative without calling Update. More...
void | InternalTransformDerivative (const double in[3], double out[3], double derivative[3][3]) override
| This will calculate the transformation, as well as its derivative without calling Update. More...
void | TemplateTransformPoint (const float in[3], float out[3])
| Do not use these methods. More...
void | TemplateTransformPoint (const double in[3], double out[3])
| Do not use these methods. More...
void | TemplateTransformPoint (const float in[3], float out[3], float derivative[3][3])
| Do not use these methods. More...
void | TemplateTransformPoint (const double in[3], double out[3], double derivative[3][3])
| Do not use these methods. More...
void | TemplateTransformInverse (const float in[3], float out[3])
| Do not use these methods. More...
void | TemplateTransformInverse (const double in[3], double out[3])
| Do not use these methods. More...
void | TemplateTransformInverse (const float in[3], float out[3], float derivative[3][3])
| Do not use these methods. More...
void | TemplateTransformInverse (const double in[3], double out[3], double derivative[3][3])
| Do not use these methods. More...
Public Member Functions inherited from vtkAbstractTransform
vtkAbstractTransform * | NewInstance () const
void | TransformPoint (const float in[3], float out[3])
| Apply the transformation to a coordinate. More...
void | TransformPoint (const double in[3], double out[3])
| Apply the transformation to a double-precision coordinate. More...
double * | TransformPoint (double x, double y, double z)
| Apply the transformation to a double-precision coordinate. More...
double * | TransformPoint (const double point[3])
double * | TransformNormalAtPoint (const double point[3], const double normal[3])
double * | TransformVectorAtPoint (const double point[3], const double vector[3])
virtual void | TransformPoints (vtkPoints *inPts, vtkPoints *outPts)
| Apply the transformation to a series of points, and append the results to outPts. More...
virtual void | TransformPointsNormalsVectors (vtkPoints *inPts, vtkPoints *outPts, vtkDataArray *inNms, vtkDataArray *outNms, vtkDataArray *inVrs, vtkDataArray *outVrs, int nOptionalVectors=0, vtkDataArray **inVrsArr=nullptr, vtkDataArray **outVrsArr=nullptr)
| Apply the transformation to a combination of points, normals and vectors. More...
vtkAbstractTransform * | GetInverse ()
| Get the inverse of this transform. More...
void | SetInverse (vtkAbstractTransform *transform)
| Set a transformation that this transform will be the inverse of. More...
void | DeepCopy (vtkAbstractTransform *)
| Copy this transform from another of the same type. More...
void | Update ()
| Update the transform to account for any changes which have been made. More...
virtual int | CircuitCheck (vtkAbstractTransform *transform)
| Check for self-reference. More...
vtkMTimeType | GetMTime () override
| Override GetMTime necessary because of inverse transforms. More...
void | UnRegister (vtkObjectBase *O) override
| Needs a special UnRegister() implementation to avoid circular references. More...
float * | TransformFloatPoint (float x, float y, float z)
| Apply the transformation to an (x,y,z) coordinate. More...
float * | TransformFloatPoint (const float point[3])
| Apply the transformation to an (x,y,z) coordinate. More...
double * | TransformDoublePoint (double x, double y, double z)
| Apply the transformation to a double-precision (x,y,z) coordinate. More...
double * | TransformDoublePoint (const double point[3])
| Apply the transformation to a double-precision (x,y,z) coordinate. More...
void | TransformNormalAtPoint (const float point[3], const float in[3], float out[3])
| Apply the transformation to a normal at the specified vertex. More...
void | TransformNormalAtPoint (const double point[3], const double in[3], double out[3])
| Apply the transformation to a normal at the specified vertex. More...
double * | TransformDoubleNormalAtPoint (const double point[3], const double normal[3])
| Apply the transformation to a double-precision normal at the specified vertex. More...
float * | TransformFloatNormalAtPoint (const float point[3], const float normal[3])
| Apply the transformation to a single-precision normal at the specified vertex. More...
void | TransformVectorAtPoint (const float point[3], const float in[3], float out[3])
| Apply the transformation to a vector at the specified vertex. More...
void | TransformVectorAtPoint (const double point[3], const double in[3], double out[3])
| Apply the transformation to a vector at the specified vertex. More...
double * | TransformDoubleVectorAtPoint (const double point[3], const double vector[3])
| Apply the transformation to a double-precision vector at the specified vertex. More...
float * | TransformFloatVectorAtPoint (const float point[3], const float vector[3])
| Apply the transformation to a single-precision vector at the specified vertex. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkCylindricalTransform * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkCylindricalTransform * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkWarpTransform
static vtkTypeBool | IsTypeOf (const char *type)
static vtkWarpTransform * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkAbstractTransform
static vtkTypeBool | IsTypeOf (const char *type)
static vtkAbstractTransform * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkCylindricalTransform ()
| ~vtkCylindricalTransform () override
void | InternalDeepCopy (vtkAbstractTransform *transform) override
| Copy this transform from another of the same type. More...
void | ForwardTransformDerivative (const float in[3], float out[3], float derivative[3][3]) override
| Calculate the forward transform as well as the derivative. More...
void | ForwardTransformDerivative (const double in[3], double out[3], double derivative[3][3]) override
| Calculate the forward transform as well as the derivative. More...
void | InverseTransformPoint (const float in[3], float out[3]) override
| If the InverseFlag is set to 1, then a call to InternalTransformPoint results in a call to InverseTransformPoint. More...
void | InverseTransformPoint (const double in[3], double out[3]) override
| If the InverseFlag is set to 1, then a call to InternalTransformPoint results in a call to InverseTransformPoint. More...
void | InverseTransformDerivative (const float in[3], float out[3], float derivative[3][3]) override
| Calculate the inverse transform as well as the derivative of the forward transform (that's correct: the derivative of the forward transform, not of the inverse transform) More...
void | InverseTransformDerivative (const double in[3], double out[3], double derivative[3][3]) override
| Calculate the inverse transform as well as the derivative of the forward transform (that's correct: the derivative of the forward transform, not of the inverse transform) More...
void | ForwardTransformPoint (const float in[3], float out[3]) override
| Internal functions for calculating the transformation. More...
void | ForwardTransformPoint (const double in[3], double out[3]) override
| Internal functions for calculating the transformation. More...
Protected Member Functions inherited from vtkWarpTransform
| vtkWarpTransform ()
| ~vtkWarpTransform () override
Protected Member Functions inherited from vtkAbstractTransform
| vtkAbstractTransform ()
| ~vtkAbstractTransform () override
virtual void | InternalUpdate ()
| Perform any subclass-specific Update. More...
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()
Protected Attributes inherited from vtkWarpTransform
vtkTypeBool | InverseFlag
int | InverseIterations
double | InverseTolerance
Protected Attributes inherited from vtkAbstractTransform
float | InternalFloatPoint [3]
double | InternalDoublePoint [3]
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

cylindrical to rectangular coords and back

vtkCylindricalTransform will convert (r,theta,z) coordinates to (x,y,z) coordinates and back again. The angles are given in radians. By default, it converts cylindrical coordinates to rectangular, but GetInverse() returns a transform that will do the opposite. The equation that is used is x = r*cos(theta), y = r*sin(theta), z = z.

Warning
  This transform is not well behaved along the line x=y=0 (i.e. along the z-axis)

See also
  vtkSphericalTransform vtkGeneralTransform

Tests:
  vtkCylindricalTransform (Tests)

Definition at line 29 of file vtkCylindricalTransform.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkWarpTransform vtkCylindricalTransform::Superclass

Definition at line 33 of file vtkCylindricalTransform.h.

## Constructor & Destructor Documentation

## ◆ vtkCylindricalTransform()

vtkCylindricalTransform::vtkCylindricalTransform | ( |  | ) |
| protected

## ◆ ~vtkCylindricalTransform()

vtkCylindricalTransform::~vtkCylindricalTransform | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkCylindricalTransform* vtkCylindricalTransform::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkCylindricalTransform::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkCylindricalTransform::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkWarpTransform.

## ◆ SafeDownCast()

static vtkCylindricalTransform* vtkCylindricalTransform::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkCylindricalTransform::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkWarpTransform.

## ◆ NewInstance()

vtkCylindricalTransform* vtkCylindricalTransform::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkCylindricalTransform::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkAbstractTransform.

## ◆ MakeTransform()

vtkAbstractTransform* vtkCylindricalTransform::MakeTransform | ( |  | ) |
| overridevirtual

Make another transform of the same type.

Implements vtkAbstractTransform.

## ◆ InternalDeepCopy()

void vtkCylindricalTransform::InternalDeepCopy | ( | vtkAbstractTransform * | transform | ) |
| overrideprotectedvirtual

Copy this transform from another of the same type.

Reimplemented from vtkAbstractTransform.

## ◆ ForwardTransformPoint() [1/2]

void vtkCylindricalTransform::ForwardTransformPoint | ( | const float | in[3],
|  | float | out[3]
| ) |  |
| overrideprotectedvirtual

Internal functions for calculating the transformation.

Implements vtkWarpTransform.

## ◆ ForwardTransformPoint() [2/2]

void vtkCylindricalTransform::ForwardTransformPoint | ( | const double | in[3],
|  | double | out[3]
| ) |  |
| overrideprotectedvirtual

Internal functions for calculating the transformation.

Implements vtkWarpTransform.

## ◆ ForwardTransformDerivative() [1/2]

void vtkCylindricalTransform::ForwardTransformDerivative | ( | const float | in[3],
|  | float | out[3],
|  | float | derivative[3][3]
| ) |  |
| overrideprotectedvirtual

Calculate the forward transform as well as the derivative.

Implements vtkWarpTransform.

## ◆ ForwardTransformDerivative() [2/2]

void vtkCylindricalTransform::ForwardTransformDerivative | ( | const double | in[3],
|  | double | out[3],
|  | double | derivative[3][3]
| ) |  |
| overrideprotectedvirtual

Calculate the forward transform as well as the derivative.

Implements vtkWarpTransform.

## ◆ InverseTransformPoint() [1/2]

void vtkCylindricalTransform::InverseTransformPoint | ( | const float | in[3],
|  | float | out[3]
| ) |  |
| overrideprotectedvirtual

If the InverseFlag is set to 1, then a call to InternalTransformPoint results in a call to InverseTransformPoint.

The inverse transformation is calculated from using Newton's method.

Reimplemented from vtkWarpTransform.

## ◆ InverseTransformPoint() [2/2]

void vtkCylindricalTransform::InverseTransformPoint | ( | const double | in[3],
|  | double | out[3]
| ) |  |
| overrideprotectedvirtual

If the InverseFlag is set to 1, then a call to InternalTransformPoint results in a call to InverseTransformPoint.

The inverse transformation is calculated from using Newton's method.

Reimplemented from vtkWarpTransform.

## ◆ InverseTransformDerivative() [1/2]

void vtkCylindricalTransform::InverseTransformDerivative | ( | const float | in[3],
|  | float | out[3],
|  | float | derivative[3][3]
| ) |  |
| overrideprotectedvirtual

Calculate the inverse transform as well as the derivative of the forward transform (that's correct: the derivative of the forward transform, not of the inverse transform)

Reimplemented from vtkWarpTransform.

## ◆ InverseTransformDerivative() [2/2]

void vtkCylindricalTransform::InverseTransformDerivative | ( | const double | in[3],
|  | double | out[3],
|  | double | derivative[3][3]
| ) |  |
| overrideprotectedvirtual

Calculate the inverse transform as well as the derivative of the forward transform (that's correct: the derivative of the forward transform, not of the inverse transform)

Reimplemented from vtkWarpTransform.

The documentation for this class was generated from the following file:

- Common/Transforms/vtkCylindricalTransform.h